local COMBAT_EVENTS = {
	["SWING_DAMAGE"] = "DAMAGE",
	["RANGE_DAMAGE"] = "DAMAGE",
	["SPELL_DAMAGE"] = "DAMAGE",
	["SPELL_PERIODIC_DAMAGE"] = "DAMAGE",
	["ENVIRONMENTAL_DAMAGE"] = "DAMAGE",
	["DAMAGE_SHIELD"] = "DAMAGE",
	["DAMAGE_SPLIT"] = "DAMAGE",
	["SPELL_HEAL"] = "HEAL",
	["SPELL_PERIODIC_HEAL"] = "HEAL",
	["SWING_MISSED"] = "MISS",
	["RANGE_MISSED"] = "MISS",
	["SPELL_MISSED"] = "MISS",
	["SPELL_PERIODIC_MISSED"] = "MISS",
	["DAMAGE_SHIELD_MISSED"] = "MISS",
	["SPELL_DRAIN"] = "DRAIN",
	["SPELL_LEECH"] = "DRAIN",
	["SPELL_PERIODIC_DRAIN"] = "DRAIN",
	["SPELL_PERIODIC_LEECH"] = "DRAIN",
	["SPELL_ENERGIZE"] = "POWER",
	["SPELL_PERIODIC_ENERGIZE"] = "POWER",
	["SPELL_INTERRUPT"] = "INTERRUPT",
	["PARTY_KILL"] = "DEATH",
	["UNIT_DIED"] = "DEATH",
	["UNIT_DESTROYED"] = "DEATH",
	["SPELL_AURA_REFRESH"] = "BUFF",
	["SPELL_AURA_APPLIED"] = "BUFF",
	["SPELL_PERIODIC_AURA_REFRESH"] = "BUFF",
	["SPELL_PERIODIC_AURA_APPLIED"] = "BUFF",
	["SPELL_AURA_APPLIED_DOSE"] = "BUFF",
	["SPELL_PERIODIC_AURA_APPLIED_DOSE"] = "BUFF",
	["SPELL_AURA_REMOVED"] = "FADE",
	["SPELL_PERIODIC_AURA_REMOVED"] = "FADE",
	["SPELL_AURA_REMOVED_DOSE"] = "FADE",
	["SPELL_PERIODIC_AURA_REMOVED_DOSE"] = "FADE",
	["ENCHANT_APPLIED"] = "ENCHANT_APPLIED",
	["ENCHANT_REMOVED"] = "ENCHANT_REMOVED",
	["SPELL_SUMMON"] = "SUMMON",
	["SPELL_CREATE"] = "SUMMON",
	["SPELL_CAST_SUCCESS"] = "SUCCESS",
	["SPELL_CAST_START"] = "SPELLSTART",
}

function pootpoot:GetMageDefaults()
	local magedefaults = {
		profile = {
			fire = "Fire!",
			fireballtgl = false,
			fireballcasttgl = false,
			fireblasttgl = false,
			pyroblasttgl = false,
			pyroblastcasttgl = false,
			scorchtgl = false,
			scorchcasttgl = false,
			dragonsbreathtgl = false,
			firecrit = true,
			firechance = 1,
			firecastchance = 0.25,
			frost = "Frost!",
			frostbolttgl = false,
			frostboltcasttgl = false,
			coneofcoldtgl = false,
			frostcrit = true,
			frostchance = 1,
			frostcastchance = 0.25,
			polymorph = "Polymorphing %t",
			polymorphtgl = false,
			polymorphchance = 1,
			blink = "Blink!",
			blinktgl = true,
			blinkchance = 1,
			arcanebarrage = "Arcane Barrage!",
			arcanebarragetgl = true,
			arcanebarragechance = 1,
			livingbomb = "Living Bomb!",
			livingbombtgl = true,
			livingbombchance = 0.25,
			deepfreeze = "I will blanket Azeroth in endless winter!",
			deepfreezetgl = true,
			deepfreezechance = 1
		}
	}
	return magedefaults
end

function pootpoot:ParseMageCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	local etype = COMBAT_EVENTS[event]
	local healtot, healamt, parent
	local amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing
	local spellId, spellName, spellSchool, missType, powerType, extraAmount, environmentalType, extraSpellId, extraSpellName, extraSpellSchool, auraType, overHeal
	local text, texture, message, inout, color

  	if not etype then
  		return
  	end

	local fromPlayer, fromPet
	if (sourceName and not CombatLog_Object_IsA(sourceFlags, COMBATLOG_OBJECT_NONE) ) then
		fromPlayer = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MINE)
	end
	if (destName and not CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_NONE) ) then
		toPlayer = CombatLog_Object_IsA(destFlags, COMBATLOG_FILTER_MINE)
		toTarget = CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_TARGET)
	end

	--if not from player or pet, then end
	if fromPlayer then
		if etype == "DAMAGE" then
			if event == "SWING_DAMAGE" then
				amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
			else
				spellId, spellName, spellSchool, amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
			text = tostring(amount)
			if event == "SPELL_DAMAGE" then
				if spellName == "Fireball" then
					if (self.db.profile.fireballtgl) then
						if (self.db.profile.firecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.firechance*100)) then
									self:DispPootMsg( self.db.profile.fire, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.firechance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Fire Blast" then
					if (self.db.profile.fireblasttgl) then
						if (self.db.profile.firecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.firechance*100)) then
									self:DispPootMsg( self.db.profile.fire, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.firechance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Pyroblast" then
					if (self.db.profile.pyroblasttgl) then
						if (self.db.profile.firecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.firechance*100)) then
									self:DispPootMsg( self.db.profile.fire, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.firechance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Scorch" then
					if (self.db.profile.scorchtgl) then
						if (self.db.profile.firecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.firechance*100)) then
									self:DispPootMsg( self.db.profile.fire, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.firechance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Dragon's Breath" then
					if (self.db.profile.dragonsbreathtgl) then
						if (self.db.profile.firecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.firechance*100)) then
									self:DispPootMsg( self.db.profile.fire, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.firechance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Frostbolt" then
					if (self.db.profile.frosttgl) then
						if (self.db.profile.frostcrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.frostchance*100)) then
									self:DispPootMsg( self.db.profile.frost, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.frostchance*100)) then
							self:DispPootMsg( self.db.profile.frost, "SAY" )
						end
					end
				elseif spellName == "Cone of Cold" then
					if (self.db.profile.coneofcoldtgl) then
						if (self.db.profile.frostcrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.frostchance*100)) then
									self:DispPootMsg( self.db.profile.frost, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.frostchance*100)) then
							self:DispPootMsg( self.db.profile.frost, "SAY" )
						end
					end
				end
			end
		elseif etype == "SUCCESS" then
			if event == "SPELL_CAST_SUCCESS" then
				spellId, spellName, spellSchool = select(1, ...)
				if spellName == "Blink" then
					if (self.db.profile.blinktgl) then
						if (math.random(100) <= (self.db.profile.blinkchance*100)) then
							self:DispPootMsg( self.db.profile.blink, "SAY" )
						end
					end
				elseif spellName == "Deep Freeze" then
					if (self.db.profile.deepfreezetgl) then
						if (math.random(100) <= (self.db.profile.deepfreezechance*100)) then
							self:DispPootMsg( self.db.profile.deepfreeze, "SAY" )
						end
					end
				elseif spellName == "Living Bomb" then
					if (self.db.profile.livingbombtgl) then
						if (math.random(100) <= (self.db.profile.livingbombchance*100)) then
							self:DispPootMsg( self.db.profile.livingbomb, "SAY" )
						end
					end
				elseif spellName == "Arcane Barrage" then
					if (self.db.profile.arcanebarragetgl) then
						if (math.random(100) <= (self.db.profile.arcanebarragechance*100)) then
							self:DispPootMsg( self.db.profile.arcanebarrage, "SAY" )
						end
					end
				end
			end
		elseif etype == "INTERRUPT" then
			if event == "SPELL_INTERRUPT" then
				spellId, spellName, spellSchool, extraSpellID, extraSpellName, extraSpellSchool = select(1, ...)
			end
		elseif etype == "MISS" then
			if event == "SPELL_MISSED" then
				spellId, spellName, spellSchool, missType, amountMissed  = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		elseif etype == "SPELLSTART" then
			if event == "SPELL_CAST_START" then
				spellId, spellName, spellSchool = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
				if spellName == "Fireball" then
					if (self.db.profile.fireballcasttgl) then
						if (math.random(100) <= (self.db.profile.firecastchance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Pyroblast" then
					if (self.db.profile.pyroblastcasttgl) then
						if (math.random(100) <= (self.db.profile.firecastchance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Scorch" then
					if (self.db.profile.scorchcasttgl) then
						if (math.random(100) <= (self.db.profile.firecastchance*100)) then
							self:DispPootMsg( self.db.profile.fire, "SAY" )
						end
					end
				elseif spellName == "Frostbolt" then
					if (self.db.profile.frostboltcasttgl) then
						if (math.random(100) <= (self.db.profile.frostcastchance*100)) then
							self:DispPootMsg( self.db.profile.frost, "SAY" )
						end
					end
				elseif string.find(spellName, "[pP]olymorph") then
					if (self.db.profile.polymorphtgl) then
						if (math.random(100) <= (self.db.profile.polymorphchance*100)) then
							self:DispPootMsg( self.db.profile.polymorph, "SAY" )
						end
					end
				end
			end
		elseif etype == "BUFF" then
			if event == "SPELL_AURA_APPLIED" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
		if etype == "POWER" then
			--if event == "SPELL_ENERGIZE" then
			--	spellId, spellName, spellSchool, amount, powerType = select(1, ...)
			--	texture = select(3, GetSpellInfo(spellId))
			--end
		end
	elseif toPlayer then
		if etype == "BUFF" then
			if event == "SPELL_AURA_REFRESH" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
	end
	if fromPlayer and toTarget then
		if destName then -- REDUNDANT?
			if event == "SPELL_AURA_APPLIED" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
	end
end