local pootpoot = LibStub("AceAddon-3.0"):GetAddon("pootpoot")

local defaults = {
	profile = {
		enabled = true,
		showMinimap = true,	-- Minimap Icon
		minimapPos = 0,
		minimapDist = 12,
		ding = "Ding!",		-- General Spells
		dingtgl = false,
		interrupt = "Interrupt!",
		interrupttgl = true,
		interruptchance = 1,
		cannibalize = "BRAINS!",
		cannibalizetgl = true,
		cannibalizechance = 1,
		bgtgl = true,
		instancetgl = true,
	}
}

local enchantprocdefaults = {
	profile = {
		crusaderproc = "Holy Strength!",
		crusaderproctgl = true,
		crusaderprocchance = 1
	}
}

local function copyTable(src, dest)
	if type(dest) ~= "table" then dest = {} end
	if type(src) == "table" then
		for k,v in pairs(src) do
			if type(v) == "table" then
				-- try to index the key first so that the metatable creates the defaults, if set, and use that table
				v = copyTable(v, dest[k])
			end
			dest[k] = v
		end
	end
	return dest
end

function pootpoot:SetupDefaults()
	copyTable(enchantprocdefaults, defaults)
	copyTable(self:GetWarriorDefaults(), defaults)
	copyTable(self:GetDeathknightDefaults(), defaults)
	copyTable(self:GetHunterDefaults(), defaults)
	copyTable(self:GetMageDefaults(), defaults)
	copyTable(self:GetPaladinDefaults(), defaults)
	copyTable(self:GetShamanDefaults(), defaults)
	copyTable(self:GetRogueDefaults(), defaults)
	copyTable(self:GetDruidDefaults(), defaults)
	copyTable(self:GetPriestDefaults(), defaults)
	copyTable(self:GetWarlockDefaults(), defaults)
	copyTable(self:GetMonkDefaults(), defaults)
	self.db = LibStub("AceDB-3.0"):New("pootpootDB", defaults, "Default")
end